
     REM This program includes a compact version of DOS_Defn.BAS, with all
     REM the routines which are not required here having been removed;
     REM RUN 6000 to start.
     REM If the DOS_Demo m/code block is not found then DOS_Defn will attempt
     REM to load it from the default LOAD medium as "DOS_DEMO" CODE 31989,410.
     REM TAP2DSK takes a TAP file copied to disk and disassembles it into its
     REM constituent files then builds a modified loader based on the initial
     REM auto-run file (if there is one) to run the game from disk.
     REM Follow the prompts; for "Output", enter @ just to list the contents
     REM of the TAP file; otherwise, A or B to actually do the extract.
     REM It should be clear from the list of contents as to whether it will
     REM be possible to build a working loader automatically or not.
     REM If the TAP includes headerless files, or the original loader doesn't
     REM load all the files at the start, or the game attempts to re-load files
     REM later on, then a new loader to run from disk will have to be prepared
     REM manually (which will entail changing the game code itself as well).

     REM The m/c routine "LC" is TAP2DSK.ASM with the offsets table removed.
     REM It needs to be on the default LOAD drive, as it gets merged into the
     REM new loader. Its ORG doesn't matter, as any absolute addresses are
     REM adjusted after merging to take account of its new location.

     REM * NOTE * The final line 9009 in the listing, which holds the machine
     REM code is there but not visible as the high byte of the line number has
     REM been POKEd with $80.

     REM 	CONSTANTS (DOS_Defn global):
k0,k1,k2,k3,k4,k5,k6,k7,k8,k9,kA,kB,kC,kD,kE,kF,kG,kK,
k31,k32,k7F,k7G,kFF,kFG,kM,k5M,h16,h32,h48,h64,
DFA,DTA,DOS,exe,o$,p$,ret
REM 	VARIABLES (DOS_Defn global):
b,c,d,e,BC,DE,IX,HL,Ae,Ar,cde,EOF,fl,d(),level(dl),g$,h(),h...,o...

d()	= DEFADD function pointer for level
dl	= function level#
h()	= function returns: (1)->(8)=DOS file header; (9)-(12)=b,c,d,e

REM 	CONSTANTS (those not already defined in DOS_Defn):
c$,dhk,e6,e9,el,en,ep,ex,hb,lv,pp
REM 	VARIABLES (those not already defined in DOS_Defn):
al,base(ba),cl,d$,db,dlen(dn),dp,flag(fg),n$(),ia,il,iq,p,q,r,page(pg),pDE,pn,pointer(pt),
q$,sf,sl,t$,tl,type(ty),DFCC,SPOS,j...
lIX,exponent(IX),mantissa(BC),number(DE),sign(HL)

al	= auto-start line number
ba	= base = read/write start address
	= hb-k3 for TAP block header
    = db    for loader line header
    = hb-sf for loader line BASIC + ENTER
cl	= current loader line number
d$	= output drive letter (or "@" for none)
db	= current byte value in loader (starts at 32768-32)
dn	= dlen = read/write block length
dp	= address of first statement in current loader line
fg	= flag = TAP block flag byte (0=header, 255=data)
    = address of byte preceding current statement in loader line
hb	= header+checksum base address (=32768-32-18)
n$()= number/filename/statement
ia	= "in number" flag
il	= "in LOAD" flag
iq	= "in quote" flag
p	= current byte value in loader line
q	= pointer to current file name in q$
r	= RANDOMIZE FN l() flag
pg	= page = current RAMpage in loader
pDE	= RAMpage changed flag
pn	= loader program length
pt	= pointer = file pointer
q$	= list of filenames in TAP file
sf	= length of loader line (excluding 4-byte header)
	= data block "last segment" flag
sl	= length of BASIC fragment to insert into loader line
	= length of data block to copy
t$	= TAP filename
	= current filename in TAP file
tl	= address of BASIC fragment to print/insert
	= length of data block copied
ty	= type = TAP block file type (0,1,2,3; or $ff="no header")


REM 	TAP2DSK.BAS

   2 GO TO VAL "6000"

 900 REM DOS_DeFn initialisation
 901 LET k0=NOT PI: LET k1=SGN PI: LET k2=k1+k1: LET k3=INT PI: LET k4=k3+k1:
     LET k5=k4+k1: LET k6=k5+k1: LET k7=k6+k1: LET k8=k7+k1: LET k9=k8+k1: LET kB=k7+k4: LET kC=kB+k1:
     LET kF=k5*k3: LET kG=k4*k4: LET k32=kG*k2: LET k7F=VAL "127": LET k7G=k7F+k1: LET kFF=k7F+k7G:
     LET kFG=kFF+k1: LET kM=VAL "1000": LET k5M=k5*kM: LET h16=VAL "16384": LET h32=h16*k2:
     LET h48=h16*k3: LET h64=h16*k4: LET DFA=VAL "23563": LET DOS=VAL "32000"
 902 DEF FN a(A$,F$,b,c,d,e)=VAL "920"
 903 DEF FN u(A$,b$,b,d)=USR DOS: REM BC returns A in B, DOS status in C
 904 DEF FN n(n,a,z)=INT ABS n AND n>=a AND n<=z: DEF FN c()=FN p(VAL "23621"):
     DEF FN p(a)=PEEK a+kFG*PEEK (a+k1): DEF FN b(l,h)=l+kFG*h:
     DEF FN l(v,d)=v-INT (v/d)*d: DEF FN d(o)=PEEK (DOS-o)
 905 IF FN p(DOS-kB)-(DOS-kB)<>VAL "410" THEN
       PRINT "Load CODE": LOAD "A:DOS_DEMO" CODE DOS-kB,VAL "410"
 910 DIM d(k4): LET dl=k1: LET ret=VAL "916": DIM h(kC): LET exe=VAL "1998":
     REM actions A,G,M,S,U,V,a,f removed, and FN x()
     LET o$="IOCRWHFDgse": LET p$=" OCRWH  gse": RETURN

 915 LET dl=dl+k1: LET d(dl)=FN p(DTA)+k8]
 916 POKE DFA+k1,k0: POKE DFA,FN l(d(dl),kFG): POKE DFA+k1,INT (d(dl)/kFG): RETURN]
 917 LET dl=dl-k1: GO TO ret
 920 RESTORE VAL "902": GO SUB ret-k1: LET g$=F$: FOR o=k1 TO LEN o$: GOSUB kM+(VAL "100" AND a$=o$(o)): NEXT o
 921 FOR h=k9 TO kC: LET h(h)=VAL VAL$ (""""+CHR$ VAL "h+57"+""""): NEXT h
 922 RESTORE FN c()+k1: GO SUB ret+k1
     REM ** THIS LINE ALTERS ITSELF; THE POKE MUST ADDRESS THE 'LET' DESTINATION **
 923 FOR h=k9 TO kC: POKE FN p(DTA)+VAL "38",VAL "h+57": LET b=h(h): NEXT h:
     LET f$=g$: RETURN

     REM NoOp RETURN if a$ doesn't match in o$
1000 RETURN
     REM select action based on a$ match in o$
1100 IF o$(o)=p$(o) THEN LET b=FN n(b,k3,kF)
1102 GO TO kM+CODE o$(o)*kA+(kM+kM AND o$(o)>="a")
1670 REM C=DOS_CLOSE
REM  GO TO exe
1680 REM D=DOS_SETDRIVE (Q=get default)
REM  GO TO exe
1700 REM F=DOS_FREESPACE
REM  LET g$=CHR$ FN n(CODE g$,CODE "A",CODE "P"+(A$<>"f")): IF NOT CODE g$ THEN GO TO kM
REM  GO TO exe
1720 REM H=DOS_REFHEAD
REM  GO TO exe
1730 REM I=DOS_INITIALISE
1731 GO TO exe
1790 REM O=DOS_OPEN: Access Mode: 1R/2W/3RW: Create Action: [0-2]: Open Action: [0-4]: File Name
1791 LET c=FN n(c,k1,k3): GO TO FN c()+c
1792 LET e=FN n(e,k0,k4): GO TO exe
1793 LET d=FN n(d,k0,k2): GO TO FN c()-k1
1794 GO TO FN c()-k1
1820 REM R=DOS_READ
REM  GO TO 1871
1870 REM W=DOS_WRITE; also for READ: Page: Address: Length
1871 LET c=FN n(c,k0,k7): LET de=FN b(e,d): LET fl=VAL g$(k2 TO)
REM  GO TO FN c()-(FN c()-kM AND NOT fl)+(k2 AND fl)+(A$="W" AND fl)

2001 IF A$="O" THEN LET g$=g$+CHR$ kFF
2003 LET BC=FN u(A$,g$,FN b(c,b),FN b(e,d)): LET Ar=INT(BC/kFG): LET Ae=FN l(BC,kFG):
     LET DE=FN p(DOS-k7): LET IX=FN p(DOS-k5): LET HL=FN p(DOS-k3):
     PRINT #k0;AT k0,VAL "27";a$;":"; INK k1+(Ae>k0);Ae-(Ae>k0),:
     IF Ae THEN PRINT "ERROR ";A$;":";Ae-k1: GO TO ex

2004 IF A$="D" THEN LET g$=CHR$ Ar: REM Default Drive
REM  IF A$="F" THEN LET g$=g$(k1): REM Free Space on Drive 'g$'='HL'kb
2007 IF A$="H" THEN POKE VAL "23388",kG+k7: FOR h=IX TO IX+k7: LET h(h-IX+k1)=PEEK h: NEXT h: REM file header at page 7 address HL
2008 IF A$="R" THEN LET HL=FN b(e,d)  REM fl bytes read at page c address HL
2010 IF A$="e" OR A$="g" THEN LET cde=FN d(k7)*h64+HL: REM File pointer = cde
2029 RETURN

4010 REM e=DOS_GETEOF
REM  GO TO exe
4030 REM g=DOS_GETPOSITION
4031 GO TO exe
4150 REM s=DOS_SETPOSITION
4151 LET de=FN b(e,d): LET cde=c*h64+de: GO TO exe

REM  POKE 23658,k0: STOP: REM End of Program

6000 DEF FN s(s$,b,d)=VAL "6500": DEF FN h(n)=n-CODE "0"-(k7 AND n>=CODE "A"):
     DEF FN j(j)=kG*FN h(PEEK (d+h+j))+FN h(PEEK (d+h+j+k1)):
    %DEF FN t(n,t)=t+k1-LEN STR$ n
6002 CLEAR VAL "32000-12": GO SUB VAL "900" :
REM %LET pt=k0: POKE VAL "23658",k8: LET q$="": LET iq=k0: LET dhk=h32-k32:
    %LET pt=k0: POKE VAL "23658",k8: DIM q$(kC): LET qc=h48-k1: LET iq=k0: LET dhk=h32-k32:
     LET db=dhk: LET hb=VAL "db-18": LET ty=kFF: REM header type $ff="no header"
    !RESTORE VAL "6413": LET pp=FN p(DTA)+k6: LET c$="0123456789.":
     LET e6=VAL "6300": LET e9=VAL "9000":
     LET el=VAL "6450": LET en=el+kA: LET ex=VAL "el+49": LET ep=VAL "7280":
     LET ia=k0: LET il=k0: DEF FN i(v)=INT (v/kFG): DEF FN o(v)=FN l(v,kFG)
6005 INPUT "TAP name ";LINE t$: IF t$(LEN t$-k3 TO)<>".TAP" THEN LET t$=t$+".TAP"
6006 INPUT "Output [@AB] ";d$: GO TO FN c()+(d$>="@" AND d$<="B")
     REM open TAP file
6010 GO SUB FN a("O",t$,k3,k1,k0,k2):
     REM get End Of File pointer
     GO SUB FN a("e","",k3,k0,k0,k0): LET EOF=cde:
     CAT t$: PRINT EOF;" bytes"
6025 IF d$<>"@" THEN
       GO SUB FN a("D",d$,k0,k0,k0,k0):
       GO SUB FN a("F",d$,k0,k0,k0,k0):
       IF HL<INT(VAL "EOF/1024") THEN PRINT "NO ROOM ON ";d$: GO TO ex
     REM read TAP block length & flag bytes
6030 IF pt>=EOF-k7F THEN GO TO VAL "6400"+(VAL "99" AND d$="@")
6040 LET ba=hb-k3: GO SUB FN s("R",k3,k3):
     REM blocks flagged as headers might not be headers
     LET dn=FN p(ba)-k2: LET fg=kFF AND (PEEK (ba+k2)=kFF OR dn<>VAL "17"):
     GO SUB VAL "7000"+kFF-fg+(kM+kFF-ty AND fg=kFF AND d$<>"@"): GO TO VAL "6030"

     REM get a filename from the h48 store
6289%FOR o=k0 TO kB: LET q$(o+k1)=CHR$ PEEK (a+o): NEXT o: RETURN

     REM update page# in page 7 file header if non-zero
6290 IF pg THEN
REM %  LET t$=q$(q TO q+kB):
    %  LET a=q: GO SUB e6-kB:
    %  GO SUB FN a("O",q$,k5,k3,k0,k1):
       GO SUB FN a("H","",k5,k0,k0,k0): POKE IX+k7,pg:
       GO SUB FN a("C","",k5,k0,k0,k0)
6300 FOR h=k1 TO LEN n$: REM print number/filename/statement in n$
       LET c=CODE n$(h): IF c>k32 THEN POKE db,c: LET db=db+k1: IF c<kFF THEN PRINT n$(h);
6301 NEXT h: RETURN

     REM save the print position
6303 LET DFCC=FN p(VAL "23684"): LET SPOS=FN p(VAL "23688"): RETURN

     REM insert NoMotor call in last line
6305 GO SUB e6+k8: LET e=FN p(dp-k2)+sl:
     POKE dp-k2,FN o(e): POKE dp-k1,FN i(e): REM update line length
     FOR h=db-k1 TO fg+k1 STEP -k1:
       POKE h+sl,PEEK h:                     REM make room & re-position cursor
     NEXT h:
     POKE VAL "23684",FN o(DFCC): POKE VAL "23685",FN i(DFCC):
     POKE VAL "23688",FN o(SPOS): POKE VAL "23689",FN i(SPOS)
6306 LET e=db-fg-k1: LET db=fg+k1: GO SUB e6+kB:REM insert & print sub-routine call
     LET tl=db: LET sl=e: GO SUB e6+kB:         REM re-print following statement
     RETURN

     REM get fragment location & length (excluding trailing ENTER)
6308 LET tl=FN p(DTA)+k5: LET sl=FN p(tl-k2)-k1: RETURN

     REM merge a new code fragment (excluding trailing ENTER) into the loader
6310 GO SUB e6+k8
6311 LET ia=k0: FOR h=tl TO tl+sl-k1:
       LET c=PEEK h: IF c=kE THEN LET ia=k6  REM don't print $0e.FP numbers
6312   IF c=VAL "205" AND PEEK (h-k2)=VAL "234" THEN
         LET ia=VAL "146"                    REM don't print m/c REM
6313   POKE db,c: LET db=db+k1: IF NOT ia THEN PRINT CHR$ c;
6314 LET ia=ia-(ia>k0): NEXT h: PAPER k7: RETURN

     REM reconstruct the loader
REM %LET n$=q$(TO kC): LET q=kF: IF n$(kA TO kC)<>"BAS" THEN GO TO ex
6400%LET a=h48: GO SUB e6-kB: LET q=h48+kE: IF q$(kA TO kC)<>"BAS" THEN GO TO ex
6401%CLS: GO SUB FN a("O",q$,k4,k3,k0,k1): LET pt=kFG: LET pg=k0: LET pDE=k0:
     GO SUB FN a("H","",k4,k0,k0,k0): LET lIX=IX: LET dn=FN p(IX+k1): LET pn=FN p(IX+k5)
6402 LET ba=db: GO SUB FN s("R",k4,k4): LET sf=FN p(ba+k2):   REM read a BASIC line header
     LET db=db+k4: LET fg=db-k1: LET dp=db: LET cl=kFG*PEEK ba+PEEK (ba+k1):
     LET ba=hb-sf: GO SUB FN s("R",k4,sf): INPUT "": REM read the remainder of the BASIC line
     PRINT TAB FN t(cl,k3);cl;: REM print the line number
     GO SUB e6+k3: PRINT " ";
     REM If it's the auto-start line, insert the preliminary code.
6403 IF cl=al THEN RESTORE e9+k3: GO SUB e6+k8: POKE tl+k2,CODE d$: GO SUB e9: PAPER k4: GO SUB e6+kB
     REM edit LOAD statements; ensure ASCII/$0e.FP numbers match
6404 FOR j=ba TO ba+sf-k1:
       LET p=PEEK j:
       REM check if in LOAD
       IF p=VAL "239" THEN
         REM insert either "LOAD" or "RANDOMIZE FN l(" depending upon page
         LET il=NOT il: LET n$=(CHR$ p AND NOT pg)+(CHR$ VAL "249"+CHR$ VAL "168"+"l(" AND pg):
         PAPER k7-pg: GO SUB e6: GO TO en
       REM check for SCREEN$,CODE,DATA,:,ENTER
6405   IF il THEN IF p=VAL "170" OR p=VAL "175" OR p=VAL "228" OR p=CODE ":" OR p=kD THEN
         REM enter closing ")" for "RANDOMIZE FN l(" if page non-zero
REM %    LET r=pg>k0 AND p=VAL "175": LET n$=""""+q$(q TO q+kB)+(CHR$ kFF AND r)+""""+(")" AND r):
    %    LET a=q: GO SUB e6-kB: LET r=pg>k0 AND p=VAL "175": LET n$=""""+q$+(CHR$ kFF AND r)+""""+(")" AND r):
         GO SUB e6-kA: LET q=q+kE: LET il=NOT il: PAPER k7: GO TO el+(kA AND r)
6406   IF il THEN GO TO en
       REM check if in quotes or REM
6407!  IF p=VAL "34" OR p=VAL "234" OR p=kD AND iq THEN LET iq=NOT iq: GO TO el
6408   IF iq THEN GO TO el
       REM check if in number
6409   IF NOT ia THEN LET d=k0:
         FOR h=k1 TO LEN c$: LET d=(d<>k0 OR p=CODE c$(h)): NEXT h:
    !    IF d THEN LET ia=k1: GO TO en
6410!  IF p<>kE THEN GO TO el
       REM convert FP number to decimal
6411   FOR h=k1 TO k5: POKE pp,CODE "AEDCB"(h)
         REM ** THIS LINE GETS ALTERED BY LINE 6411 (SEE LINE 6002 FOR pp ASSIGNMENT) **
6413     LET A=PEEK (j+h): NEXT h:
6415   IF NOT a THEN
         LET DE=kFG*c+d: LET DE=DE-(h64 AND e=kFF):
         GO TO VAL "6421"
6417   LET IX=a-k7G: LET HL=-k1:
       IF e<=k7F THEN LET HL=+k1: LET e=e+k7G
6420   LET BC=VAL "e/kFG+d/h64+c/16777216+b/4294967296":
       LET DE=HL*k2^IX*BC
6421!  LET n$=STR$ DE: LET pg=(DE-(kG AND DE>=kG)) AND pDE: GO SUB e6: REM POKE ASCII number
    !  LET pDE=pDE+(DE=VAL "23388" OR DE=VAL "32765"): LET ia=k0:
       FOR h=k0 TO k5: POKE db+h,PEEK (j+h): NEXT h:  REM POKE $0e.FP number
       LET db=db+k6: LET j=j+k5: GO TO en
       REM If it's the auto-start line, append the DEF FN statement & m/code.
6450   IF p=kD AND cl=al THEN   REM el
         RESTORE e9+k5: PAPER k4: GO SUB e6+kA: RESTORE e9+k9: PAPER k4: GO SUB e6+kA
6451   IF NOT ia THEN PRINT CHR$ p;: POKE db,p: LET db=db+k1
6452   IF p=CODE ":" THEN
         IF NOT (ia+il+iq) THEN REM save position of last ":"
    !      LET pDE=k0: LET fg=db-k1: GO SUB e6+k3
6460 NEXT j: REM en update line length
     POKE dp-k2,FN o(db-dp): POKE dp-k1,FN i(db-dp):
     IF pt-kFG<pn THEN GO TO VAL "6402"
6461 RESTORE e9+k7: PAPER k4: GO SUB e6+k5: REM insert NoMotor call in last line
     IF dn-pn THEN LET ba=db: GOSUB FN s("R",k4,dn-pn): REM read in any variables data
     REM write new loader & finish
REM %LET n$=q$(TO kC): GO SUB FN a("s","",k4,k0,k0,k7G): LET ba=dhk: REM reset file & data pointers
6480%GO SUB FN a("s","",k4,k0,k0,k7G): LET ba=dhk: REM reset file & data pointers
     LET dn=db-ba+(dn-pn): LET pn=db-ba
6481 GO SUB FN s("W",k4,dn): LET IX=lIX:
     POKE IX+k1,FN o(dn): POKE IX+k2,FN i(dn): POKE IX+k5,FN o(pn): POKE IX+k6,FN i(pn):
     GO SUB FN a("C","",k4,k0,k0,k0)
     REM end of program
6499 LET BC=FN u("I","",k0,k0): POKE VAL "23658",k0: STOP

     REM read/write 'd' bytes from/to file 'b' to/from 'ba' (s$=R/W)
6500 RESTORE VAL "6000": GO SUB ret-k1: LET l$="="+STR$ d: LET c=k5-(k3 AND ba>=h32):
     LET pt=pt+(d AND s$="R"): GO SUB FN a(s$,l$,b,c,FN i(ba),FN o(ba)): GO TO ret+k1
     REM missing header
6555 IF ty=kFF THEN
       PRINT "* Code";TAB k8;"NO HEADER";TAB kK;"Bytes:";TAB FN t(dn,k31);dn
6556 RETURN
     REM select routine for tape file data block (fg=255) & checksum
     REM skip tape file data block (fg=255) & checksum
7000 GO SUB VAL "6555": LET ba=db: LET pt=pt+dn+k1:
     REM force c,d,e to be smallint
     LET lv=VAL "23406": POKE lv,INT (pt/h64): POKE lv+k1,FN i(FN l(pt,h64)): POKE lv+k2,FN o(pt):
     GO SUB FN a("s","",k3,PEEK lv,PEEK (lv+k1),PEEK (lv+k2)): LET ty=kFF: RETURN
     REM invalid 1<= fg byte <=254
     REM lines 7001-7254 reserved for error jumps
7254 PRINT "Bad Flag: ";fg: GO TO ex
     REM read tape file header block (fg=0) & checksum
7255 LET ba=hb: GO SUB FN s("R",k3,dn+k1): INPUT "":
     LET ty=PEEK ba: LET o=ty*k4+k1:
     PRINT ty;" ";"ProgNumbCharCode"(o TO o+k3);TAB k8;: DIM n$(kK)
7256 LET o=k0: LET IX=k8: LET h=ba: GO SUB ep: LET n$(k9)=".":
     LET o=k9: LET IX=kB: GO SUB ep:
     LET o=kC: LET IX=k0: GO SUB ep
7258 LET BC=FN p(ba+kB): PRINT TAB kK;"Bytes:";TAB FN t(BC,k31);BC;TAB k2;:
     LET DE=FN p(ba+kD): LET DE=DE AND (DE<=VAL "9999" OR ty=k3): LET HL=FN p(ba+kF)
7260 IF ty=k0 THEN PRINT "Auto:";TAB FN t(DE,kD);DE;TAB kK;"Prog:";TAB FN t(HL,k31);HL:
     LET al=DE
7261 IF ty=k1 OR ty=k2 THEN
       PRINT "Array: ";CHR$ (PEEK (ba+kE)-k32-(k32*k2 AND ty=k2));"$" AND ty=k2;"()"
7263 IF ty=k3 THEN PRINT "Start:";TAB FN t(DE,kD);DE
7264 IF ty>k3 THEN PRINT "Bad Type: ";ty: GO TO ex
7265 IF n$(kA TO kC)="   " OR NOT ty THEN LET n$(kA TO kC)="BASNUMCHRCOD"(ty*k3+k1 TO ty*k3+k3)
REM %PRINT #k0;AT k0,k0;n$: LET q$=q$+n$(TO kE):
7270%PRINT #k0;AT k0,k0;n$: FOR o=k1 TO kE: POKE qc+o,CODE n$(o): NEXT o: LET qc=qc+kE:
     RETURN
     REM print old file name & build new file name
7280 FOR h=h+k1 TO ba+kA:
       LET d=PEEK h: PRINT CHR$ d;:
       IF d>=CODE "#" AND o<=IX AND d<>CODE "." AND d<>CODE "-" AND d<>CODE ":" THEN
         LET o=o+k1: LET n$(o)=CHR$ (d-(k32 AND d>=CODE "a"))
7281   IF NOT IX OR o<=IX AND d<>CODE "." THEN NEXT h
7282 RETURN
     REM copy tape file data block (fg=255), skip checksum
8000 LET n$="N"+"00000"(TO k5-LEN STR$ pt)+STR$ pt: PRINT #k0;AT k0,k0;n$: REM assign a headerless file name
     REM lines 8001-8254 reserved for entry jumps
8255 GO SUB FN a("O",n$,k4,k2,k1+(ty=kFF),k4):
     IF ty<>kFF THEN
       GO SUB FN a("H","",k4,k0,k0,k0): REM returns IX=header address
       POKE IX,ty: FOR h=k1 TO k6: POKE IX+h,PEEK (hb+kB+h-k1): NEXT h: POKE IX+k7,k0
     REM copy data block in 16kb segments plus a remainder segment
8256 GO SUB VAL "6555": LET tl=k0
8260 LET dn=dn-h16: LET sf=(dn<=k0): LET sl=h16-(h16-(dn+h16) AND sf):
     LET ba=db: PRINT TAB FN t(sl,kD);sl,"=> ";: GO SUB FN s("R",k3,sl+sf): GO SUB FN s("W",k4,sl):
     LET tl=tl+sl: PRINT TAB FN t(tl,kK+k3);tl: GO TO FN c()+sf
8261 GO SUB FN a("C","",k4,k0,k0,k0): LET ty=kFF: RETURN

     REM adjust any absolute addresses for loader, *NOT* for here
     REM c = (PROG) + length of preceding lines + length of this line
     REM            + length of preceding additions to this line
9000 LET c=FN p(VAL "23635")+VAL "db-dhk+sf-1+27+24+2":
     RESTORE e9+k9: LET b=FN p(DTA)+k7: LOAD "A:LC" CODE b,VAL "146": POKE FN p(DTA)+k1,k7G:
     RESTORE e9+k3: LET d=FN p(DTA)-k31
9001 FOR h=k0 TO k4 STEP k2:
       LET n$=STR$ (c+FN j(k0)):
       RESTORE e9+k5+h: LET a=FN p(DTA)-k8:
       FOR o=k1 TO k5: POKE a+o,CODE n$(o): NEXT o: REM insert correct value for "?????" below
     NEXT h
9002 FOR h=k6 TO VAL "26" STEP k4:
       LET a=b+FN j(k0): LET o=c+FN j(k2): POKE a,FN o(o): POKE a+k1,FN i(o):
     NEXT h:
     RETURN: DATA "4D005C016E4E6E5D6E427F597F6B7F": REM m/c address offsets

     REM The following lines are for merging into the new loader,
     REM they are not executed directly.
     REM ** DON'T FORGET TRAILING ':' **
     REM m/c addresses are updated while constructing auto-start line
9003 LOAD "?:": CLEAR VAL "31988": RANDOMIZE USR VAL "?????":      REM no DOS or RAM caches
9005 : DEF FN l(f$)=USR VAL "?????": REM load CODE when page > 0
9007 RANDOMIZE USR VAL "?????":      REM turn off disk motor & timer
9009 REM "<--m/c 146 bytes-->"       REM ** NO TRAILING ':' **